#ifndef SCROLLINGAREAWIDGETINTEL_H
#define SCROLLINGAREAWIDGETINTEL_H

#include <QObject>
#include <QWidget>
#include <QSlider>
#include <QHBoxLayout>
#include <QLabel>
#include <QIcon>
#include <QDebug>
#include <QGSettings>
#include <QMouseEvent>
#include <QEvent>
#include <QPainterPath>
#include <QPainter>
#include <QStylePainter>
#include <QStyleOptionSlider>
#include <QApplication>
#include <QVBoxLayout>

#define UKUI_VOLUME_BRIGHTNESS_GSETTING_ID "org.ukui.quick-operation.panel"
#define UKUI_VOLUME_KEY "volumesize"
#define UKUI_MUTE_KEY   "soundstate"

#define KYLIN_POWER_MODE_GSETTING_VALUE        "org.ukui.power-manager"
#define UKUI_BRIGHTNESS_KEY "brightness-ac"

#define KYLIN_VOLUME_PRESS_PATH            ":/image/pad_volumeopen.svg"
#define KYLIN_VOLUME_MUTE_PATH            ":/image/pad_muteopen.svg"

#define KYLIN_LIGHT_NORMAL_PATH            ":/image/pad_icon-light.svg"
#define KYLIN_LIGHT_PRESS_PATH             ":/image/pad_icon-lightopen.svg"

#define UKUI_QT_STYLE                      "org.ukui.style"
#define UKUI_STYLE_KEY                     "style-name"

class SliderButtonIntel;
class ScrollingAreaWidgetIntel : public QWidget
{
    Q_OBJECT
public:
    ScrollingAreaWidgetIntel(QWidget *parent = nullptr);

private:
    void initMemberVariable();
    void initGsettingValue();
    void initSlideStatus();
    void initLayout();

private:
    QHBoxLayout *m_pHMainLayout;

    QWidget     *m_pVolumeWidget;
    QLabel      *m_pVolumeIconLabel;
    QSlider     *m_pVolumeSlide;
    QVBoxLayout *m_pVVolumeLayout;

    QWidget     *m_pBrightNessWidget;
    QLabel      *m_pBrightIconLabel;
    QSlider     *m_pBrightSlide;
    QVBoxLayout *m_pBrightLayout;

    SliderButtonIntel *sliderP1;
    SliderButtonIntel *sliderP2;
    QGSettings  *m_pVolumeLightSetting;
    QGSettings  *m_pBrightNessSetting;
    QGSettings  *m_briSettings;
    QGSettings  *m_style;

    bool        autobristatus;
    bool        mute;

private slots:
    void setSliderValue(QString key);
    void setVolumeSlideSlots(int value);
    void setBrightSlideSlots(int value);
    void setSCrollStyle(QString key);
    void setVoice(int num);
    void setBright(int num);

};


class SliderButtonIntel : public QSlider
{
    Q_OBJECT
public:
    explicit SliderButtonIntel(QWidget *parent = 0);

    void mousePressEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);

    bool clickState = false;
    int i = 0;

Q_SIGNALS:
    void ycoordinate(int num);


};


#endif // SCROLLINGAREAWIDGETINTEL_H
